#include "stdafx.h"
#include "resource.h"
#include "CustListCtrl.h"

IMPLEMENT_DYNAMIC(CCustListCtrl, CListCtrl)

CCustListCtrl::CCustListCtrl()
: m_dragFrom(-1), m_dropTo(-1), m_dragImage(0), m_overItem(-1)
{
	m_il.Create(32, 32, ILC_COLOR32|ILC_MASK, 1, 1);
	m_il.Add(::AfxGetApp()->LoadIcon(IDR_MAINFRAME));
}

CCustListCtrl::~CCustListCtrl()
{
	if (m_dragImage)
		delete m_dragImage;
}

int CCustListCtrl::GetCurSel() const
{
	POSITION pos = GetFirstSelectedItemPosition();
	return (pos ? GetNextSelectedItem(pos) : -1);
}

void CCustListCtrl::PreSubclassWindow()
{
	CListCtrl::PreSubclassWindow();
	SetImageList(&m_il, LVSIL_NORMAL);
}

BEGIN_MESSAGE_MAP(CCustListCtrl, CListCtrl)
	ON_NOTIFY_REFLECT(LVN_BEGINDRAG, OnBeginDrag)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
END_MESSAGE_MAP()

void CCustListCtrl::OnBeginDrag(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	if (pNMLV)
	{
		m_dragFrom = GetCurSel();
		if (m_dragFrom != -1)
		{
			CPoint ptItem;
			m_dragImage = CreateDragImage(m_dragFrom, &ptItem);
			if (m_dragImage)
			{
				CPoint ptHotSpot = CPoint(pNMLV->ptAction) - ptItem;
				m_dragImage->BeginDrag(0, ptHotSpot);
				m_dragImage->DragEnter(CWnd::GetDesktopWindow(), pNMLV->ptAction);
				SetCapture();
			}
		}
	}
	*pResult = 0;
}

void CCustListCtrl::OnMouseMove(UINT nFlags, CPoint point)
{
	if (m_dragImage)
	{
		CPoint ptDrag(point);
		ClientToScreen(&ptDrag);
		m_dragImage->DragMove(ptDrag);
	}
	CListCtrl::OnMouseMove(nFlags, point);
}

void CCustListCtrl::OnLButtonUp(UINT nFlags, CPoint point)
{
	if (m_dragImage)
	{
		::ReleaseCapture();
		m_dragImage->DragLeave(CWnd::GetDesktopWindow());
		m_dragImage->EndDrag();

		delete m_dragImage;
		m_dragImage = 0;
	}
	CListCtrl::OnLButtonUp(nFlags, point);
}
